/* This file is is generated by a shell script.  DO NOT EDIT! */

/* Emulate the original gld for the given msp430elf
   Copyright (C) 2014-2020 Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com
   Extended for the MSP430 by Nick Clifton  nickc@redhat.com

   This file is part of the GNU Binutils.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
   MA 02110-1301, USA.  */

#define TARGET_IS_msp430elf

#include "sysdep.h"
#include "bfd.h"
#include "bfdlink.h"
#include "ctf-api.h"

#include "ld.h"
#include "getopt.h"
#include "ldmain.h"
#include "ldmisc.h"
#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"
#include "libiberty.h"
#include "ldelf.h"
#include <ldgram.h>

enum regions
{
  REGION_NONE = 0,
  REGION_LOWER,
  REGION_UPPER,
  REGION_EITHER = 3,
};

enum either_placement_stage
{
  LOWER_TO_UPPER,
  UPPER_TO_LOWER,
};

enum { ROM, RAM };

static int data_region = REGION_NONE;
static int code_region = REGION_NONE;
static bfd_boolean disable_sec_transformation = FALSE;

#define MAX_PREFIX_LENGTH 7

#include "elf-bfd.h"
#include "ldelfgen.h"



static void
gldmsp430elf_after_open (void)
{
  bfd *ibfd;
  asection *sec;
  asymbol **syms;

  after_open_default ();

  if (bfd_link_relocatable (&link_info))
    for (ibfd = link_info.input_bfds; ibfd != NULL; ibfd = ibfd->link.next)
      if ((syms = bfd_get_outsymbols (ibfd)) != NULL
	  && bfd_get_flavour (ibfd) == bfd_target_elf_flavour)
	for (sec = ibfd->sections; sec != NULL; sec = sec->next)
	  if ((sec->flags & (SEC_GROUP | SEC_LINKER_CREATED)) == SEC_GROUP)
	    {
	      struct bfd_elf_section_data *sec_data = elf_section_data (sec);
	      struct bfd_symbol *sym = syms[sec_data->this_hdr.sh_info - 1];
	      elf_group_id (sec) = sym;
	      sym->flags |= BSF_KEEP;
	    }

  if (bfd_get_flavour (link_info.output_bfd) != bfd_target_elf_flavour
      || bfd_link_relocatable (&link_info))
    return;

  FOR_MSYM_IN_MSYM_HASH_TABLE (link_info.output_bfd, i, entry, msym)
    {
      /* Orphan SMK_LOCATION sections by renaming them so they don't match a
         linker script rule.  We can then move the new output sections around,
         or remove those output sections to put the input section in a
         different, existing output section.  */
      if (msym->msym.kind == SMK_LOCATION)
	/* FIXME include the address in the name.  */
	bfd_rename_section (msym->sym->section, concat (".smi.location.", msym->sym->name, (const char *)NULL));
    }
}

static void
gldmsp430elf_before_allocation (void)
{
  if (bfd_link_relocatable (&link_info)
      && !_bfd_elf_size_group_sections (&link_info))
    einfo (_("%X%P: can not size group sections: %E\n"));
  before_allocation_default ();
}

/* Return the SMK_LOCATION metasym with the lowest value in S.
   Return NULL if there is no SMK_LOCATION metasym in S.  */
static struct bfd_elf_metasym_hash_entry *
check_sec_for_locsym (asection *s)
{
  struct bfd_elf_metasym_hash_entry *ret = NULL;
  FOR_MSYM_IN_MSYM_HASH_TABLE (link_info.output_bfd, i, entry, msym)
    {
      if (msym->msym.kind == SMK_LOCATION && msym->sym->section == s
	  && (ret == NULL || msym->msym.value < ret->msym.value))
	ret = msym;
    }
  return ret;
}

/* Return a pointer to the input section statement for input section IS within
   the list L.  If there is a padding statement immediately preceding the input
   section, return that.  */
static lang_statement_union_type **
find_input_section_statement (lang_statement_union_type ** l, asection *is)
{
  lang_statement_union_type ** prev_pad = NULL;
  lang_statement_union_type ** ret;
  for (; (*l) != NULL; l = &(*l)->header.next)
    {
      switch ((*l)->header.type)
	{
	case lang_input_section_enum:
	  if ((*l)->input_section.section == is)
	    {
	      return (prev_pad != NULL ? prev_pad : l);
	    }
	  break;

	case lang_padding_statement_enum:
	  prev_pad = l;
	  break;

	case lang_wild_statement_enum:
	  ret = find_input_section_statement (&(*l)->wild_statement.children.head, is);
	  if (ret != NULL)
	    return ret;
	  break;

	default:
	  break;
	}

      /* Unless we set prev_pad on the previous iteration, reset it.  */
      if ((*l)->header.type != lang_padding_statement_enum)
	prev_pad = NULL;
    }
  return NULL;
}

static bfd_vma
locsym_addr_adj_required (struct bfd_elf_metasym_hash_entry *msym)
{
  asection *is = msym->sym->section;
  asection *os = msym->sym->section->output_section;

  lang_relax_sections (FALSE);
  return msym->msym.value - os->vma - is->output_offset;
}

/* Insert an assignment statement before IS, to move it forward by AMT bytes.
   We silently return if AMT is negative, as we assume a postive AMT will be
   set for this section on a subsequent call.  */
static void
insert_ass (asection *is, bfd_size_type amt)
{
  lang_statement_union_type *ass = NULL;
  asection *os = is->output_section;
  lang_output_section_statement_type * os_stat;
  lang_statement_union_type **ptr;

  if ((long)amt < 0)
    return;

  /* Find the location at which to insert the assignment statement.  */
  os_stat = lang_output_section_find (os->name);
  ptr = find_input_section_statement (&os_stat->children.head, is);

  if (!ptr)
    return;

  /* Make a new assignment statement, linked into existing chain.  */
  ass = stat_alloc (sizeof (lang_assignment_statement_type));
  ass->header.next = *ptr;
  *ptr = ass;
  ass->header.type = lang_assignment_statement_enum;
  /* Set the dot to the desired address, relative to the beginning of the
     output section of IS.  */
  ass->assignment_statement.exp
    = exp_assign (".", exp_intop (is->output_offset + amt), FALSE);

  lang_relax_sections (FALSE);
}

/* Insert input section before PTR.  */
static void
insert_input_section (asection *is, lang_statement_union_type **ptr)
{
  lang_statement_union_type *sec = NULL;
  sec = stat_alloc (sizeof (lang_input_section_type));
  sec->input_section.section = is;
  sec->header.type = lang_input_section_enum;
  sec->header.next = *ptr;
  *ptr = sec;
}

/* Initialize an output section with a wild statement.  */
static void
insert_wild (lang_statement_list_type *list)
{
  lang_wild_statement_type *wild = NULL;

  wild = stat_alloc (sizeof (lang_wild_statement_type));
  wild->header.next = NULL;
  wild->header.type = lang_wild_statement_enum;

  wild->filename = NULL;
  wild->filenames_sorted = FALSE;
  wild->section_flag_list = NULL;
  wild->exclude_name_list = NULL;
  wild->section_list = NULL;
  wild->keep_sections = FALSE;
  lang_list_init (&wild->children);

  *(list->tail) = (void *)wild;
  list->tail = &wild->header.next;

  lang_relax_sections (FALSE);
}

/* Initialize a new lang_statement_union_type with the given output section
   statement.  */
static lang_statement_union_type *
insert_os_stat (lang_output_section_statement_type *os_stat)
{
  lang_statement_union_type *new_stmt;
  new_stmt = stat_alloc (sizeof (lang_output_section_statement_type));
  new_stmt->header.type = lang_output_section_statement_enum;

  new_stmt->output_section_statement = *os_stat;
  new_stmt->output_section_statement.addr_tree = NULL;
  new_stmt->header.next = NULL;
  return new_stmt;
}



/* Below are a collection of functions used for sorting sections by their
   expected output VMA.  These have been adapted from their original definitions
   in ld/lang.c.  */

/* Compare sections ASEC and BSEC according to SORT.  */
static int
compare_section (asection *sec1, asection *sec2)
{
  /* We add the section size to the VMA of non-locsym sections so that if a
     locsym VMA is in the middle of a section, that section will be placed after
     the locsym section and the locsym can be added to the correct location.  */
  bfd_vma vma1 = sec1->output_section->vma + sec1->output_offset + sec1->size;
  bfd_vma vma2 = sec2->output_section->vma + sec2->output_offset + sec2->size;
  struct bfd_elf_metasym_hash_entry *msym1 = check_sec_for_locsym (sec1);
  struct bfd_elf_metasym_hash_entry *msym2 = check_sec_for_locsym (sec2);
  if (msym1)
    vma1 = msym1->msym.value;
  if (msym2)
    vma2 = msym2->msym.value;

  if (vma1 < vma2)
    return -1;
  /* If a locsym and non-locsym have the same expected output VMA, we
     prioritize the locsym and place that first.  */
  if (vma1 == vma2 && msym1 && !msym2)
    return -1;
  return 0;
}

/* Build a Binary Search Tree to sort sections, unlike insertion sort
   used in wild_sort().  BST is considerably faster if the number of
   of sections are large.  */
static lang_section_bst_type **
wild_sort_fast (lang_section_bst_type **tree,
		asection *section)
{
  while (*tree)
    {
      /* Find the correct node to append this section.  */
      if (compare_section (section, (*tree)->section) < 0)
	tree = &((*tree)->left);
      else
	tree = &((*tree)->right);
    }
  return tree;
}

/* Use wild_sort_fast to build a BST to sort sections.  */
static void
output_section_callback_fast (lang_section_bst_type **tree,
			      asection *section)
{
  lang_section_bst_type *node;

  node = (lang_section_bst_type *) xmalloc (sizeof (lang_section_bst_type));
  node->left = 0;
  node->right = 0;
  node->section = section;

  tree = wild_sort_fast (tree, section);
  if (tree != NULL)
    *tree = node;
}


/* Convert a sorted sections' BST back to list form.  */
static void
output_section_callback_tree_to_list (lang_statement_list_type *ptr,
				      lang_section_bst_type *tree,
				      void *output)
{
  if (tree->left)
    output_section_callback_tree_to_list (ptr, tree->left, output);

  tree->section->output_section = NULL;

  lang_add_section (ptr, tree->section, NULL,
		    (lang_output_section_statement_type *) output);

  struct bfd_elf_metasym_hash_entry *msym = check_sec_for_locsym (tree->section);
  bfd_vma adj;
  if (msym != NULL
      && ((adj = locsym_addr_adj_required (msym)) != 0))
    insert_ass (tree->section, adj);

  if (tree->right)
    output_section_callback_tree_to_list (ptr, tree->right, output);

  free (tree);
}

/* End BST sorting.  */


/* Shuffle the input sections within ROOT so they are ordered in ascending
   output VMA order, taking into account the desired VMA of SMK_LOCATION
   metasyms.  */
static void
shuffle_secs (lang_statement_list_type *root)
{
  lang_section_bst_type *node;
  lang_statement_union_type *l;
  lang_output_section_statement_type *os;
  if (root->head == NULL)
    return;

  /* We might have a padding or assignment statement at the beginning of the
     wild, so find the first input section.  */
  for (l = root->head; l != NULL; l = l->header.next)
    if (l->header.type == lang_input_section_enum)
      break;

  if (l == NULL)
    return;

  node = (lang_section_bst_type *) xmalloc (sizeof (lang_section_bst_type));
  node->left = 0;
  node->right = 0;
  node->section = l->input_section.section;

  for (l = l->header.next; l != NULL; l = l->header.next)
    if (l->header.type == lang_input_section_enum)
      output_section_callback_fast (&node, l->input_section.section);

  lang_list_init (root);
  os = lang_output_section_find (node->section->output_section->name);
  output_section_callback_tree_to_list (root, node, os);

  lang_relax_sections (FALSE);
}

/* Return TRUE if the address specified for the SMK_LOCATION metasym MSYM is
   within the range of addresses spanned by the input sections in L.  */
static bfd_boolean
calc_wild_range (lang_statement_list_type *l,
		 struct bfd_elf_metasym_hash_entry *msym)
{
  bfd_vma start = 0;
  bfd_vma end = 0;
  lang_statement_union_type *i;
  asection *is = NULL;
  lang_relax_sections (FALSE);
  for (i = l->head; i != NULL; i = i->header.next)
    {
      if (i->header.type != lang_input_section_enum)
	continue;
      is = i->input_section.section;

      /* L should be sorted by output VMA, but we do some extra checks
	 anyway...  */
      if (start == 0 || is->output_offset + is->output_section->vma < start)
	start = is->output_offset + is->output_section->vma;

      if (is->output_offset + is->output_section->vma + is->size > end)
	end = is->output_offset + is->output_section->vma + is->size;
    }

  if (msym->msym.value >= start && msym->msym.value <= end)
    return TRUE;
  return FALSE;
}

/* Descend into the statement list which begins at ROOT, and detach S from the
   wild statement it is in if PLACE is FALSE.
   If DUMP is TRUE, print some debugging statements.
   Return TRUE once we've found and detached the input section.  */
static bfd_boolean
detach_input_sec (asection *s, lang_statement_list_type *root,
		  bfd_boolean dump)
{
  asection *is;
  lang_statement_union_type * prev = NULL;
  lang_statement_union_type * curr;

  if (root == stat_ptr && dump)
    printf ("\ndetach_input_sec\n");

  for (curr = root->head; curr != NULL; curr = curr->header.next)
    {
      switch (curr->header.type)
	{
	case lang_input_section_enum:
	  is = curr->input_section.section;
	  if (dump)
	    printf ("    input section %s\n", is->name);
	  if (is == s)
	    {
	      if (dump)
		printf ("    detaching this sec %s\n", is->name);

	      if (s->output_section
		  && strncmp (s->output_section->name, ".smi.location.", strlen (".smi.location.")) != 0)
		s->output_section = bfd_get_section_by_name (link_info.output_bfd, s->name);

	      /* If this is the last statement, and we are detaching this
		 statement, we have to point the list tail to the previous
		 elements' next pointer.  */
	      if (curr->header.next == NULL)
		root->tail = &prev->header.next;

	      /* Adjust the next statement pointed to by the previous element.  */
	      if (prev == NULL)
		root->head = curr->header.next;
	      else
		prev->header.next = curr->header.next;

	      /* This statement is no longer part of any list, so clear the next
		 element it points to.  */
	      curr->header.next = NULL;

	      /* In case we remove subsequent entries, always maintain prev to
		 be the last one that was actually kept in the list (prev gets set to
		 curr at the end of this function).  */
	      curr = prev;

	      lang_relax_sections (FALSE);
	      return TRUE;
	    }
	  break;

	case lang_output_section_statement_enum:
	  if (!curr->output_section_statement.bfd_section)
	    break;
	  if (dump && curr->output_section_statement.bfd_section)
	    printf ("    output section %s VMA 0x%lx size 0x%lx\n", curr->output_section_statement.name, curr->output_section_statement.bfd_section->vma,  curr->output_section_statement.bfd_section->size);

	  /* Descend into this output section.  */
	  if (detach_input_sec (s, &curr->output_section_statement.children, dump))
	    return TRUE;
	  break;

	case lang_wild_statement_enum:
	  if (dump)
	    printf ("    wild statement\n");
	  if (detach_input_sec (s, &curr->wild_statement.children, dump))
	    return TRUE;
	  break;

	case lang_group_statement_enum:
	  if (dump)
	    printf ("    group statement section\n");
	  if (detach_input_sec (s, &curr->group_statement.children, dump))
	    return TRUE;
	  break;

	default:
	  break;
	}
      prev = curr;
    }
  return FALSE;
}

/* Detach the output section S from the list that starts from root.  */
static bfd_boolean
detach_output_sec (asection *s, lang_statement_list_type *root,
		  bfd_boolean dump)
{
  asection *os;
  lang_statement_union_type * prev = NULL;
  lang_statement_union_type * curr;
  lang_output_section_statement_type * os_stat;

  if (dump)
    printf ("\ndetach_output_sec\n");

  for (curr = root->head; curr != NULL; curr = curr->header.next)
    {
      switch (curr->header.type)
	{
	case lang_output_section_statement_enum:
	  os_stat = &curr->output_section_statement;
	  if (!os_stat->bfd_section)
	    break;

	  if (dump && os_stat->bfd_section)
	    printf ("    output section %s VMA 0x%lx size 0x%lx\n",
		    os_stat->name,
		    os_stat->bfd_section->vma,
		    os_stat->bfd_section->size);

	  os = os_stat->bfd_section;

	  if (os == s)
	    {
	      if (dump)
		printf ("    detaching here\n");

	      /* If this is the last statement, and we are detaching this
		 statement, we have to point the list tail to the previous
		 elements' next pointer.  */
	      if (curr->header.next == NULL)
		root->tail = &prev->header.next;

	      /* Adjust the next statement pointed to by the previous element.  */
	      if (prev == NULL)
		root->head = curr->header.next;
	      else
		prev->header.next = curr->header.next;

	      /* This statement is no longer part of any list, so clear the next
		 element it points to.  */
	      curr->header.next = NULL;

	      /* In case we remove subsequent entries, always maintain prev to
	         be the last one that was actually kept in the list (prev gets set to
		 curr at the end of this function).  */
	      curr = prev;

	      lang_relax_sections (FALSE);
	      return TRUE;
	    }
	  break;

	case lang_group_statement_enum:
	  if (dump)
	    printf ("    group statement section\n");
	  if (detach_output_sec (s, &curr->group_statement.children, dump))
	    return TRUE;
	  break;

	default:
	  if (dump)
	    printf ("    statement type %d\n", curr->header.type);
	  break;
	}
      prev = curr;
    }
  return FALSE;
}

/* Convenience function to detach a locsym entirely from ROOT (orphan it).
   If the output section of the locsym is a "real" section that was specified
   in the linker script, i.e. not an output section created just for the locsym,
   we do not detach that output section from ROOT.  */
static void
detach_locsym (struct bfd_elf_metasym_hash_entry *msym, lang_statement_list_type *root,
		  bfd_boolean dump)
{
  asection *os = msym->sym->section->output_section;
  detach_input_sec (msym->sym->section, root, dump);
  if (os
      && strncmp (os->name, ".smi.location.", strlen (".smi.location.")) == 0)
    detach_output_sec (msym->sym->section->output_section, stat_ptr, dump);
}

/* A list of generic wild rules which we can put a locsym in without it
   disturbing some special ordering specified by the linker script.
   We are trying to avoid placing locsyms inside a wild statement for
   sections such as .crt*, .{init,fini}_array}, .{ctors,dtors} etc.
   We also use this to deduce the type of a memory region.
   XXX Changes to this list must be reflect in the wild_whitelist_elem enum.
   FIXME, should make this an array of struct wiht one elem being the string
   and the other being the associated type.  */
static const char * wild_whitelist[34] = {
    ".text",		".text.*",
    ".upper.text",	".upper.text.*",
    ".lower.text",	".lower.text.*",
    ".either.text",	".either.text.*",

    ".rodata",		".rodata.*",
    ".upper.rodata",	".upper.rodata.*",
    ".lower.rodata",	".lower.rodata.*",
    ".either.rodata",	".either.rodata.*",

    ".data",		".data.*",
    ".upper.data",	".upper.data.*",
    ".lower.data",	".lower.data.*",
    ".either.data",	".either.data.*",

    ".bss",		".bss.*",
    ".upper.bss",	".upper.bss.*",
    ".lower.bss",	".lower.bss.*",
    ".either.bss",	".either.bss.*",

    "COMMON",

    /* Terminate the list.  */
    NULL
};

enum wild_whitelist_elem {
    WW_READONLY = 0,
    WW_TEXT = 0,
    WW_RODATA = 8,
    WW_READ_WRITE = 16,
    WW_DATA = 16,
    WW_BSS = 24,
};

#define LOCSYM_FLAG_MASK (SEC_DATA | SEC_LOAD | SEC_READONLY | SEC_CODE)

#define LOCSYM_SEC_DATA (SEC_DATA | SEC_LOAD)
#define LOCSYM_SEC_RODATA (SEC_DATA | SEC_LOAD | SEC_READONLY)
#define LOCSYM_SEC_BSS (0)
#define LOCSYM_SEC_TEXT (SEC_CODE | SEC_READONLY | SEC_LOAD)

/* Rules for placement within wilds:
   DATA -> (DATA | RODATA | TEXT)
     We can place .data in .rodata or .text because we know the memory region
     is writeable.  The initial value of the data will be loaded as if it was
     .rodata.
   RODATA -> (DATA | RODATA | TEXT)
     We can't place .rodata in .bss because the initial load value will be
     overwritten when the .bss output section is zero'd.
     We should be able to place .rodata in .data, since the memory region is
     loadable, so they are treated the same except .rodata shouldn't be overwritten
     by the program.
   BSS -> (DATA | RODATA | BSS | TEXT)
     We can place .bss anywhere because the memory region is writeable, and the
     VMA of the variable will be stored in __smi_location_init_array, and so
     will be initialized to 0 just before main.
   TEXT -> (DATA | RODATA | TEXT)
     When LMA of .data != VMA, then as long as the .text section has its contents
     in the LMA area, then it can be copied to DATA. Like a RAMFUNC.

   TODO if we could save the initial values of text/data/rodata somewhere
   (like an LMA region for these variables), we could also place them in a
   RAM-like memory region and initialize them with
   __crt0_run_smi_location_init_array.  */

/* This contains all the required logic to decide if we can place a section
   with MSYM_FLAGS inside a wild statement or memory region with TARGET_FLAGS.
   The decision making changes depending on if we are checking if the region is
   compatible (CHECK_REGION_COMPAT == TRUE), or a wild is compatible.
   One of the key points for below is that we can't place anything with an
   initial value in the .bss section, unless that value is going to be copied
   over from a different LMA using smi_location_run_init_array, because bss
   initialization will wipe the loaded values at the VMA.  */
static bfd_boolean
verify_flag_compatibility (flagword msym_flags, flagword target_flags,
			   bfd_boolean check_region_compat)
{
  msym_flags &= LOCSYM_FLAG_MASK;
  target_flags &= LOCSYM_FLAG_MASK;

  if (msym_flags == target_flags)
    return TRUE;

  if (msym_flags == LOCSYM_SEC_BSS)
    {
      /* We can place .bss anywhere writeable.  */
      if (check_region_compat && ((target_flags & SEC_READONLY) == 0))
	return TRUE;

      if (!check_region_compat)
	/* Place .bss locsyms anywhere if the region is already compatible.  */
	return TRUE;

      return FALSE;
    }

  /* We can place .text/.rodata/.data anywhere except .bss if the region is
     compatible.  */
  if (!check_region_compat
      && (target_flags == LOCSYM_SEC_DATA
	  || target_flags == LOCSYM_SEC_TEXT
	  || target_flags == LOCSYM_SEC_RODATA))
    return TRUE;

  if (msym_flags == LOCSYM_SEC_DATA)
    {
      /* We can place .data anywhere writeable.  */
      if (check_region_compat && ((target_flags & SEC_READONLY) == 0))
	return TRUE;
      return FALSE;
    }

  if (msym_flags == LOCSYM_SEC_TEXT)
    {
      /* We can place .text anywhere executable.  */
      if (check_region_compat && (target_flags & SEC_CODE))
	return TRUE;
      return FALSE;
    }

  if (msym_flags == LOCSYM_SEC_RODATA)
    {
      /* We can place .rodata anywhere readonly.  */
      if (check_region_compat && (target_flags & SEC_READONLY))
	return TRUE;
      return FALSE;
    }
  return FALSE;
}

static flagword
get_flags_for_wild (int allowed_wild)
{
  if (allowed_wild >= WW_BSS)
    return LOCSYM_SEC_BSS;
  else if (allowed_wild >= WW_DATA)
    return LOCSYM_SEC_DATA;
  else if (allowed_wild >= WW_RODATA)
    return LOCSYM_SEC_RODATA;
  else
    return LOCSYM_SEC_TEXT;
}

/* Find the wild statement within os_stat that would contain the target address
   of MSYM, and return TRUE if that wild statement is compatible with the type
   of MSYM.
   Before this function is called, we've already confirmed that MSYM is
   compatible with the memory region of OS_STAT (e.g. for a .data MSYM, the
   region is writeable).  */
static bfd_boolean
verify_wild_compatibility (struct bfd_elf_metasym_hash_entry *msym,
			   lang_output_section_statement_type * os_stat)
{
  lang_statement_list_type * list = &os_stat->children;
  lang_statement_union_type *curr;
  struct wildcard_list *wild_list = NULL;
  const int dump = 0;
  flagword msym_flags = msym->sym->section->flags & LOCSYM_FLAG_MASK;
  lang_wild_statement_type *target_wild = NULL;

  if (dump)
    printf ("trying to place locsym %s with flags 0x%x\n",
	    msym->sym->name, msym_flags);

  /* Find the wild statement containing the target address.  */
  for (curr = list->head; curr != NULL; curr = curr->header.next)
    {
      if (curr->header.type == lang_wild_statement_enum
	  && calc_wild_range (&curr->wild_statement.children, msym))
	{
	  target_wild = &curr->wild_statement;
	  break;
	}
      else if (curr->header.type == lang_input_section_enum)
	{
	  /* The msp430 .either placement just attaches .either input
	     sections to the corresponding output section.
	     This should be the only case of input sections directly attached
	     to the output section's child list that we need to handle.  */
	  asection *s = curr->input_section.section;
	  if (!s)
	    continue;

	  if (strncmp (s->name, ".either.", strlen (".either.")) == 0)
	    {
	      const char *allowed_wild_str = NULL;
	      int allowed_wild;

	      for (allowed_wild = 0, allowed_wild_str = wild_whitelist[allowed_wild];
		   allowed_wild_str != NULL;
		   allowed_wild_str = wild_whitelist[++allowed_wild])
		{
		  if (strncmp (allowed_wild_str, s->name, strlen(allowed_wild_str)) == 0)
		    break;
		}
	      flagword wild_flags = get_flags_for_wild (allowed_wild);

	      if (verify_flag_compatibility (msym_flags, wild_flags, FALSE))
		return TRUE;
	    }
	}
    }

  /* We couldn't find a wild statement containing the target address.  */
  if (target_wild == NULL)
    return FALSE;

  /* Iterate over each of the individual wild rules in the wild
     statement.  */
  for (wild_list = target_wild->section_list;
       wild_list != NULL; wild_list = wild_list->next)
    {
      const char *allowed_wild_str = NULL;
      int allowed_wild;

      /* Check this is a wild statement we know to have no special
	 properties or enforced ordering of its elements, so we can
	 place any locsym within it.  */
      for (allowed_wild = 0, allowed_wild_str = wild_whitelist[allowed_wild];
	   allowed_wild_str != NULL;
	   allowed_wild_str = wild_whitelist[++allowed_wild])
	{
	  if (strcmp (allowed_wild_str, wild_list->spec.name) == 0)
	    break;
	}

      /* The wild statement was not on the whitelist.  */
      if (allowed_wild_str == NULL)
	continue;

      flagword wild_flags = get_flags_for_wild (allowed_wild);

      if (verify_flag_compatibility (msym_flags, wild_flags, FALSE))
	return TRUE;
    }
  /* We've examined all the wild rules within the wild statement that
     contains our target address, and none of the rules were acceptable for
     the locsym, so we can't place the locsym within this output
     section.  */
  return FALSE;
}

static bfd_boolean
verify_region_compatibility (lang_memory_region_type *region,
			    lang_statement_list_type *root,
			    flagword section_flags)
{
  /* Go over all the output/input sections within a region and build up a
   * flagword variable which has all the types of sections within that region.
   * That helps us work out if the region is ROM/RAM/FRAM.  */

  /* If the program doesn't have sections of a certain type within a region, we
   * may not accurately deduce what is allowed within that region.  In that
   * case we need to also check the wild statements allowed in that region
   * again known names to help us work out the flags.  */

  const int dump = 0;
  section_flags &= LOCSYM_FLAG_MASK;

  /* Start with the flags set on the region, if any.  We use the not flags at
     the end.  */
  if (verify_flag_compatibility (section_flags, region->flags, TRUE))
    return TRUE;

  lang_statement_union_type * curr = NULL;
  for (curr = root->head; curr != NULL; curr = curr->header.next)
    {
      switch (curr->header.type)
	{
	case lang_output_section_statement_enum:
	  if (curr->output_section_statement.region == region)
	    {
	      asection *os = curr->output_section_statement.bfd_section;
	      const char *secname;
	      int allowed_wild;
	      if (os == NULL)
		continue;
	      if (dump)
		printf ("  %s is in the same region with flags 0x%x\n", os->name, os->flags & LOCSYM_FLAG_MASK);

	      if (verify_flag_compatibility (section_flags, os->flags, TRUE))
		return TRUE;

	      /* If the output section does not have any contents then the
		 flags will be incomplete.  So infer the flags from its
		 name.  */
	      for (allowed_wild = 0, secname = wild_whitelist[allowed_wild];
		   secname != NULL;
		   secname = wild_whitelist[++allowed_wild])
		{
		  if (strcmp (secname, os->name) != 0)
		    continue;

		  flagword wild_flags = get_flags_for_wild (allowed_wild);
		  if (verify_flag_compatibility (section_flags, wild_flags, TRUE))
		    return TRUE;
		  break;
		}

	      /* We still haven't decided this output section is compatible, so
	         look at its children.  */
	      if (verify_region_compatibility (region, &curr->output_section_statement.children, section_flags))
		return TRUE;
	    }
	  break;
	case lang_wild_statement_enum:
	  if (root == stat_ptr)
	    /* We should only have found a wild_statement when descending into
	       the list attached to an output_section_statement.  */
	    break;

	  if (dump)
	    printf ("    wild statement %s\n", curr->wild_statement.section_list->spec.name);

	  struct wildcard_list *wild_list;
	  for (wild_list = curr->wild_statement.section_list;
	       wild_list != NULL; wild_list = wild_list->next)
	    {
	      const char *allowed_wild_str;
	      int allowed_wild;
	      /* Check this is a wild statement we know to have no special
		 properties or enforced ordering of its elements, so we can
		 place any locsym within it.  */
	      for (allowed_wild = 0, allowed_wild_str = wild_whitelist[allowed_wild];
		   allowed_wild_str != NULL;
		   allowed_wild_str = wild_whitelist[++allowed_wild])
		{
		  if (strcmp (allowed_wild_str, wild_list->spec.name) == 0)
		    break;
		}
	      if (allowed_wild_str != NULL)
		{
		  flagword wild_flags = get_flags_for_wild (allowed_wild);
		  if (verify_flag_compatibility (section_flags, wild_flags, TRUE))
		    return TRUE;
		  break;
		}
	    }
	  break;
	default:
	  break;
	}
    }
  /* FIXME handling ! region flags */
  /*region_flags &= !(region->not_flags);*/

  return FALSE;
}

/* Check a memory region exists at the given address, and that we can
   place the locsym in that region.  */
static lang_memory_region_type *
validate_locsym_addr (struct bfd_elf_metasym_hash_entry *msym, bfd_boolean validate_flags)
{
  bfd_vma addr = msym->msym.value;
  lang_memory_region_type *r;
  for (r = get_memory_region_list (); r != NULL; r = r->next)
    {
      if (addr >= r->origin && addr < r->origin + r->length
	  /* The default memory region spans the entire address space.  */
	  && strcmp ("*default*", r->name_list.name) != 0)
	{
	  /* Check the region we want to place the locsym in is compatible with its
	     section type.  */
	  if (validate_flags
	      && (!verify_region_compatibility (r, stat_ptr, msym->sym->section->flags)))
	    {
	      einfo (_("%P: warning: SMK_LOCATION metasym '%s' is not compatible "
		       "with the memory region '%s' containing address 0x%v\n"),
		      msym->sym->name, r->name_list.name, msym->msym.value);
	      return NULL;
	    }
	  return r;
	}
    }
  if (validate_flags)
    einfo (_("%P: warning: no valid memory region at address 0x%v for "
	     "SMK_LOCATION metasym '%s'\n"), msym->msym.value,
	   msym->sym->name);
  return NULL;
}

/* Create a list of SMK_LOCATION metasyms, sorted in ascending order of their
   desired VMA.
   Return the number of locsyms in the list.
   TODO we could use a faster algorithm for creating this sorted list.  */
static unsigned int
create_sorted_locsym_list (struct bfd_elf_metasym_hash_entry **list)
{
  unsigned int placed = 0;
  unsigned int j;
  const int dump = 0;
  FOR_MSYM_IN_MSYM_HASH_TABLE (link_info.output_bfd, i, entry, msym)
    {
      if (msym->msym.kind != SMK_LOCATION)
	continue;

      if (link_info.gc_sections && !msym->sym->section->gc_mark)
	{
	  if (dump)
	    printf ("%s has been garbage collected\n", msym->sym->section->name);
	  continue;
	}

      if (dump)
	printf ("create_sorted_locsym_list for %s\n", msym->sym->name);


      if (check_sec_for_locsym (msym->sym->section) != msym)
	{
	  einfo (_("%P: warning: only one SMK_LOCATION metasym allowed per section. "
		   "ignoring metasym '%s' in section %s\n"),
		   msym->sym->name, msym->sym->section->name);
	  continue;
	}

      /* Before we go any further, validate the address of locsym.
	 We may not be able to place it at all.  */
      if (validate_locsym_addr (msym, TRUE) == NULL)
	continue;

      /* Detach the locsyms from the global statement list.  This ensures that
         regular sections are in accurate positions each time we go to look at
         placing the locsyms.  */
      detach_locsym (msym, stat_ptr, FALSE);

      if (placed == 0)
	{
	  list[0] = msym;
	  placed++;
	  continue;
	}
      for (j = 0; j < placed; j++)
	{
	  if (msym->msym.value < list[j]->msym.value)
	    {
	      unsigned int k;
	      for (k = placed; k > j; k--)
		list[k] = list[k - 1];
	      list[j] = msym;
	      break;
	    }
	}
      if (j == placed)
	list[j] = msym;
      placed++;
    }
  return placed;
}

/* For the given locsym MSYM, find the output section which would contain
   its desired output value.
   We don't do any validation that the return output section is actually
   compatible with MSYM.  */
static lang_output_section_statement_type *
find_containing_os (struct bfd_elf_metasym_hash_entry *msym)
{
  lang_statement_union_type * curr = stat_ptr->head;
  lang_output_section_statement_type * os_stat;
  bfd_vma addr = msym->msym.value;
  const int dump = 0;
  if (dump)
    printf ("\nfind_containing_os for %s at addr 0x%lx\n", msym->sym->name, addr);

  for (curr = stat_ptr->head; curr != NULL; curr = curr->header.next)
    {
      switch (curr->header.type)
	{

	case lang_output_section_statement_enum:
	  os_stat = &curr->output_section_statement;
	  /* Only consider output sections which will actually be part of the
	     executing program.  */
	  if (os_stat->bfd_section && (os_stat->bfd_section->flags & SEC_ALLOC))
	    {
	      if (dump)
		printf ("  %s vma 0x%lx size 0x%lx\n", os_stat->bfd_section->name,
			os_stat->bfd_section->vma, os_stat->bfd_section->size);

	      /* Check if the locsym would have to be placed within an existing
		 output section.  */
	      if (addr >= os_stat->bfd_section->vma
		  && addr < (os_stat->bfd_section->vma
			     + os_stat->bfd_section->size))
		return os_stat;
	    }
	  break;

	default:
	  break;
	}
    }
  return NULL;
}

/* Return TRUE if OS_STAT is the last output section in it's memory region.
   This accounts for non-consecutive output sections assigned to the same
   memory region, only the last output section counts.  */
static bfd_boolean
last_os_in_region (lang_statement_union_type *os_stat)
{
  lang_statement_union_type *curr;
  lang_memory_region_type *region = os_stat->output_section_statement.region;
  for (curr = os_stat->header.next; curr != NULL; curr = curr->header.next)
    {
      switch (curr->header.type)
	{
	case lang_output_section_statement_enum:
	  if (curr->output_section_statement.region == region)
	    return FALSE;
	default:
	  /* FIXME: Do we need to handle group statements?  */
	  break;
	}
    }
  return TRUE;
}

/* Place msym before the output section os_stat. If os_stat is NULL, there
   should be free space at the desired address of MSYM and we attach it to the
   statement list as required.  */
static lang_output_section_statement_type *
move_locsym_os (struct bfd_elf_metasym_hash_entry *msym, lang_statement_list_type *root,
		lang_output_section_statement_type * before_os_stat)
{
  lang_statement_union_type * curr = root->head;
  lang_statement_union_type * prev = NULL;
  bfd_vma addr = msym->msym.value;
  lang_output_section_statement_type * os_stat;
  asection *os;
  const int dump = 0;

  /* We detached the output section statements for all locsyms earlier, now
     find it, and reattach it.  */
  os_stat = lang_output_section_find (msym->sym->section->output_section->name);

  /* We don't seem to be able to get a list of output sections attached to a
   * given region, so just iterate over the output sections till we find it.
   If we don't see the region, we can just create a new output section statement
   and attach it to the region.  */
  /* BUT we need to make sure to operate within regions here, since the
   * sections are only ordered according to VMA within regions, and we will
   * sometimes need to place it at the end of the region.  */

  for (curr = root->head; curr != NULL; curr = curr->header.next)
    {
      switch (curr->header.type)
	{
	case lang_output_section_statement_enum:
	  if (curr->output_section_statement.bfd_section
	      && validate_locsym_addr (msym, FALSE) == curr->output_section_statement.region)
	    {
	      os = curr->output_section_statement.bfd_section;
	      if (dump)
		printf ("  %s vma 0x%lx size 0x%lx\n", os->name,
			os->vma, os->size);

	      /* Update the memory region if necessary.  */
	      os_stat->region = curr->output_section_statement.region;

	      /* If we've gone past the desired VMA of our locsym, we need to
	         insert its section before this one.  */
	      if (os->vma >= addr
		  || (before_os_stat && os == before_os_stat->bfd_section))
		{
		  lang_statement_union_type *new_stmt = insert_os_stat (os_stat);
		  new_stmt->output_section_statement.addr_tree = exp_intop (addr);

		  if (dump)
		    printf ("  INSERT %s HERE, before %s\n", msym->sym->name, os->name);

		  if (prev == NULL)
		    root->head = new_stmt;
		  else
		    prev->header.next = new_stmt;

		  new_stmt->header.next = curr;
		  return &new_stmt->output_section_statement;

		}
	      /* If we've reached the end of the statement list, or the next
	         output section is in a different memory region, attach the
	         locsym after the current output section.  */
	      else if (curr->header.next == NULL
		       || last_os_in_region (curr))
		{
		  lang_statement_union_type *new_stmt = insert_os_stat (os_stat);
		  new_stmt->output_section_statement.addr_tree = exp_intop (addr);

		  if (dump)
		    printf ("    INSERT %s HERE, after %s\n", msym->sym->name, os->name);

		  if (curr->header.next == NULL)
		    {
		      new_stmt->header.next = NULL;
		      root->tail = &new_stmt->header.next;
		    }
		  else
		    new_stmt->header.next = curr->header.next;

		  curr->header.next = new_stmt;

		  return &new_stmt->output_section_statement;
		}
	    }
	  break;
	default:
	  if (dump)
	    printf ("  statement type %d\n", curr->header.type);
	  break;
	}
      prev = curr;
    }
  return NULL;
}

static bfd_boolean
insert_locsym_init_arr_start (void )
{
  lang_statement_union_type * curr = NULL;
  lang_relax_sections (FALSE);

  for (curr = stat_ptr->head; curr != NULL; curr = curr->header.next)
    {
      switch (curr->header.type)
	{
	case lang_output_section_statement_enum:
	  if (curr->output_section_statement.bfd_section
	      && strcmp (curr->output_section_statement.bfd_section->name,
			 ".smi.location_init_array") == 0)
	    {
	      /* FIXME this gets orphaned at the end of the map file would be
		 good to attach it for aesthetics.  */
	      lang_add_assignment (exp_provide ("__smi_location_init_array_start",
						exp_intop (curr->output_section_statement.bfd_section->vma),
						FALSE));
	      return TRUE;
	    }
	  break;
	default:
	  break;
	}
    }
  return FALSE;
}

/* Place SMK_LOCATION* meta-information entries (abbreviated as "locsyms") at
   their requested addresses, if possible.  */
static void
place_locsyms (void)
{
  if (elf_metasym_count (link_info.output_bfd) == 0)
    return;

  struct bfd_elf_metasym_hash_entry **list
    = xmalloc (sizeof (struct bfd_elf_metasym_hash_entry *)
	       * elf_metasym_count (link_info.output_bfd));
  unsigned int num_loc = create_sorted_locsym_list (list);
  bfd_boolean need_locsym_init_array = (num_loc != 0);
  unsigned int i, j;
  lang_output_section_statement_type * os_stat;
  struct bfd_elf_metasym_hash_entry * msym;
  const int dump = 0;

  unsigned int loopnum = 0;
  unsigned int max_loopnum = (num_loc * num_loc) + 100;
  max_loopnum = (max_loopnum < num_loc ? (unsigned int)-1 : max_loopnum);
  bfd_boolean changed_locsym_list = FALSE;

  /* FIXME need to detect if we are in an endless loop.
     e.g. when two locsyms
     keep changing order in the list with no progress being made,
     and report to the user that "the selected placement is not possible".  */
   do
    {
      if (loopnum++ > max_loopnum)
	break;

      if (dump)
	printf ("\n******************\nstarting loop over %d msyms again\n", num_loc);

      for (i = 0; i < num_loc; i++)
	{
	  msym = list[i];
	  os_stat = find_containing_os (msym);

	  /* If there is no existing output section at the desired VMA of the
	     locsym, we can place it directly.
	     If the locsym does overlap with an output section, and the wild
	     statement we would try to place it in is not compatible with the
	     locsym type, we have to place the locsym's output section before
	     that output section.
	     Note that we cannot place locsyms directly inside an output
	     section, (e.g. in a new wild statement) as that might disturb
	     assignments or other special ordering enforced by the linker
	     script.
	     We only place within allowed wild statements inside the output
	     section, or in an entirely new output section.  */
	  if (os_stat == NULL
	      || !verify_wild_compatibility (msym, os_stat))
	    {
	      if (dump)
		printf ("\nplace %s freely (move_locsym_os) - target addr 0x%lx\n", msym->sym->name, msym->msym.value);

	      if ((os_stat = move_locsym_os (msym, stat_ptr, os_stat)) == NULL)
		{
		  einfo (_("%P: error: unable to place SMK_LOCATION "
			   "metasym %s\n"), msym->sym->name);
		  continue;
		}

	      /* Refresh this .smi.location output section, which should only
	         ever contain a .smi.location input section.  */
	      lang_list_init (&os_stat->children);
	      insert_wild (&os_stat->children);
	      /* We need to clear the output section before calling
		 lang_add_section.  */
	      msym->sym->section->output_section = NULL;
	      lang_add_section (&os_stat->children.head->wild_statement.children,
				msym->sym->section, NULL, os_stat);
	    }
	  else
	    {
	      if (dump)
		printf ("\nplace %s within %s - target addr 0x%lx\n", msym->sym->name, os_stat->bfd_section->name, msym->msym.value);

	      lang_statement_union_type *curr;
	      lang_statement_union_type *prev = NULL;
	      for (curr = os_stat->children.head; curr != NULL; prev = curr, curr = curr->header.next)
		{
		  /* Input sections are always within wild statements within output
		     sections, even if the input section in rule in the linker script
		     does not contain any wildcards.
		     The exception is msp430 .either sections, these are
		     attached directly to the output section and are handled below.  */
		  if (curr->header.type == lang_wild_statement_enum
		      && calc_wild_range (&curr->wild_statement.children, msym))
		    {
		      /* If the specified VMA of the locsym is within the range of this
			 wild, we must shuffle the input sections within the wild
			 statement to get it placed at the right address.  */
		      msym->sym->section->output_section = NULL;
		      lang_add_section (&curr->wild_statement.children,
					msym->sym->section, NULL,
					os_stat);
		      shuffle_secs (&curr->wild_statement.children);
		      break;
		    }
		  else if (curr->header.type == lang_input_section_enum)
		    {
		      bfd_vma either_addr;

		      asection *s = curr->input_section.section;
		      if (!s)
			continue;
		      if (strncmp (s->name, ".either.", strlen (".either.")) != 0)
			continue;

		      either_addr = os_stat->bfd_section->vma + s->output_offset + s->size;

		      /* Find the first either section after our desired
		         VMA.  */
		      if (either_addr < msym->msym.value)
			continue;

		      if (dump)
			printf ("  place %s before %s\n", msym->sym->section->name, s->name);

		      msym->sym->section->output_section = os_stat->bfd_section;

		      if (prev == NULL)
			insert_input_section (msym->sym->section, &os_stat->children.head);
		      else
			insert_input_section (msym->sym->section, &prev->header.next);

		      insert_ass (msym->sym->section, locsym_addr_adj_required (msym));
		      break;
		    }
		}
	      if (curr == NULL)
		einfo (_("%P: internal error placing SMK_LOCATION metasym %s\n"),
			 msym->sym->name);
	    }
	  lang_relax_sections (FALSE);

	  /* Check if the locsym we just played has ruined the placement of any
	     of the locsyms we placed earlier.  */
	  unsigned int new_idx = 0;
	  unsigned int num_placed = i;
	  unsigned int new_num_loc = num_loc;
	  changed_locsym_list = FALSE;
	  for (j = 0; j < num_loc; j++)
	    {
	      struct bfd_elf_metasym_hash_entry *inv_msym = list[j];
	      bfd_vma adj;
	      /* Only consider the locsyms already placed.  */
	      if (j < num_placed
		  && (adj = locsym_addr_adj_required (inv_msym)) != 0)
		{
		  struct bfd_elf_metasym_hash_entry **new_list;

		  if (dump)
		    printf ("ADJUSTMENT REQUIRED for %s (curr 0x%lx target 0x%lx) after placing %s\n",
			    inv_msym->sym->name, inv_msym->msym.value - adj, inv_msym->msym.value, msym->sym->name);

		  /* If we're stuck placing the first locsym, and we haven't
		     placed any locsyms yet, there's no shuflling we'll be able
		     to do to get it to fit, so don't try to place it.  */
		  if (j == 0 && num_placed == 0)
		    {
		      einfo (_("%P: warning: unable to accurately place SMK_LOCATION metasym %s\n"),
			     msym->sym->name);
		      /* Setting j to 1 means this locsym will be removed from
		         the worklist.  */
		      j = 1;
		    }

		  /* We've "locked in" the first J msyms, so remove these from
		     the work list.  */
		  new_num_loc -= j;
		  new_list = xmalloc (sizeof (struct bfd_elf_metasym_hash_entry *)
				      * new_num_loc);

		  /* Move the locsym we just placed, which invalidated the later
		     locsyms, to the front of the list.  */
		  if (dump)
		    printf ("moving %s from pos %d to pos %d\n", msym->sym->name, i, new_idx);
		  new_list[new_idx++] = msym;

		  detach_locsym (msym, stat_ptr, FALSE);
		  for (; j < num_loc; j++)
		    {
		      inv_msym = list[j];
		      /* Don't place the locsym we moved to the front of the
			 list again.  */
		      if (inv_msym == new_list[0])
			continue;

		      if (dump)
			printf ("new moving %s from pos %d to pos %d\n", inv_msym->sym->name, j, new_idx);
		      new_list[new_idx++] = inv_msym;
		      detach_locsym (inv_msym, stat_ptr, FALSE);
		    }

		  /* Copy to the old list then free the new list.  */
		  num_loc = new_num_loc;
		  for (j = 0; j < num_loc; j++)
		    list[j] = new_list[j];
		  free (new_list);

		  changed_locsym_list = TRUE;
		  break;
		}
	      else if (j >= num_placed)
		{
		  /* All locsyms placed so far have had their addresses
		     successfully validated.  */
		  break;
		}
	    }
	  if (changed_locsym_list)
	    /* Start again with the new list.  */
	    break;
	}
    } while (changed_locsym_list);

   /* We may not have any locsyms anymore if they were garbage collected, but
      the init_array table and crt0_run_smi_location_init_array have already
      been created and the output executable finalized so we must define the
      symbol to prevent "undefined reference to...".
      However, if we don't NEED the symbol to be defined, don't error if the
      init_array section can't be found.  */
   if (!insert_locsym_init_arr_start () && need_locsym_init_array )
     einfo (_("%P: couldn't find .smi.location_init_array section to define "
	      "__smi_location_init_array_start"));
}

/* Once we've placed all the locsyms, remove any left over BFD output sections
 * from locsyms which have now been placed within other "real" sections.  */
static void
fixup_os_list (void)
{
  asection *s;
  for (s = link_info.output_bfd->sections; s != NULL; s = s->next)
    {
      if (strncmp (s->name, ".smi.location.", strlen (".smi.location.")) != 0)
	continue;

      if (s->size == 0)
	{
	  bfd_section_list_remove (link_info.output_bfd, s);
	  link_info.output_bfd->section_count--;
	}
    }
}

static void
gldmsp430elf_after_allocation (void)
{
  /* Check the output format is ELF and that we aren't doing a relocatable link.  */
  if (bfd_get_flavour (link_info.output_bfd) != bfd_target_elf_flavour
      || bfd_link_relocatable (&link_info))
  {
    ldelf_map_segments (FALSE);
    return;
  }

  if (elf_tdata (link_info.output_bfd))
    {
      place_locsyms ();
      fixup_os_list ();
    }
  ldelf_map_segments (FALSE);
}

static void
gldmsp430elf_before_parse (void)
{
#ifndef TARGET_			/* I.e., if not generic.  */
  ldfile_set_output_arch ("msp:14", bfd_arch_unknown);
#endif /* not TARGET_ */

  /* The MSP430 port *needs* linker relaxtion in order to cope with large
     functions where conditional branches do not fit into a +/- 1024 byte range.  */
  if (!bfd_link_relocatable (&link_info))
    TARGET_ENABLE_RELAXATION;
}


static char *
gldmsp430elf_get_script (int *isfile)
{
  *isfile = 0;

  if (bfd_link_relocatable (&link_info) && config.build_constructors)
    return
"/* Script for -Ur */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader 0 :\n\
  {\n\
    *(.bootloader)\n\
  }\n\
  /* Information memory.  */\n\
  .infomem 0 :\n\
  {\n\
    *(.infomem)\n\
  }\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits 0 :\n\
  {\n\
    *(.infomemnobits)\n\
  }\n\
  /* Read-only sections, merged into text segment.  */\n"
"  .hash        0 : { *(.hash)             }\n\
  .dynsym      0 : { *(.dynsym)           }\n\
  .dynstr      0 : { *(.dynstr)           }\n\
  .gnu.version 0 : { *(.gnu.version)      }\n\
  .gnu.version_d 0 : { *(.gnu.version_d)  }\n\
  .gnu.version_r 0 : { *(.gnu.version_r)  }\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n\
    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.rodata  0 :\n\
    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n"
"    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.ctors   0 : { *(.rel.ctors)        }\n\
  .rela.ctors  0 : { *(.rela.ctors)       }\n\
  .rel.dtors   0 : { *(.rel.dtors)        }\n\
  .rela.dtors  0 : { *(.rela.dtors)       }\n\
  .rel.got     0 : { *(.rel.got)          }\n\
  .rela.got    0 : { *(.rela.got)         }\n\
  .rel.bss     0 : { *(.rel.bss)          }\n\
  .rela.bss    0 : { *(.rela.bss)         }\n\
  .rel.plt     0 : { *(.rel.plt)          }\n\
  .rela.plt    0 : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text 0 :\n\
  {\n\
     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    *(.text)\n"
"  }\n\
  .rodata 0 :\n\
  {\n\
    *(.rodata)\n\
  }\n\
  .vectors 0 :\n\
  {\n\
    *(.vectors)\n\
  }\n\
  .data 0 :\n\
  {\n\
    *(.data)\n\
  }\n\
  .bss 0 :\n\
  {\n\
    *(.bss.* .bss)\n\
  }\n\
  .noinit 0 :\n\
  {\n\
    *(.noinit)\n\
  }\n\
  .persistent 0 :\n\
  {\n\
    *(.persistent)\n\
  }\n"
"  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
}\n\n"
  ; else if (bfd_link_relocatable (&link_info)) return
"/* Script for -r */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader 0 :\n\
  {\n\
    *(.bootloader)\n\
  }\n\
  /* Information memory.  */\n\
  .infomem 0 :\n\
  {\n\
    *(.infomem)\n\
  }\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits 0 :\n\
  {\n\
    *(.infomemnobits)\n\
  }\n\
  /* Read-only sections, merged into text segment.  */\n"
"  .hash        0 : { *(.hash)             }\n\
  .dynsym      0 : { *(.dynsym)           }\n\
  .dynstr      0 : { *(.dynstr)           }\n\
  .gnu.version 0 : { *(.gnu.version)      }\n\
  .gnu.version_d 0 : { *(.gnu.version_d)  }\n\
  .gnu.version_r 0 : { *(.gnu.version_r)  }\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n\
    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.rodata  0 :\n\
    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n"
"    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.ctors   0 : { *(.rel.ctors)        }\n\
  .rela.ctors  0 : { *(.rela.ctors)       }\n\
  .rel.dtors   0 : { *(.rel.dtors)        }\n\
  .rela.dtors  0 : { *(.rela.dtors)       }\n\
  .rel.got     0 : { *(.rel.got)          }\n\
  .rela.got    0 : { *(.rela.got)         }\n\
  .rel.bss     0 : { *(.rel.bss)          }\n\
  .rela.bss    0 : { *(.rela.bss)         }\n\
  .rel.plt     0 : { *(.rel.plt)          }\n\
  .rela.plt    0 : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text 0 :\n\
  {\n\
    *(.text)\n\
  }\n\
  .rodata 0 :\n\
  {\n\
    *(.rodata)\n\
  }\n\
  .vectors 0 :\n"
"  {\n\
    *(.vectors)\n\
  }\n\
  .data 0 :\n\
  {\n\
    *(.data)\n\
  }\n\
  .bss 0 :\n\
  {\n\
    *(.bss.* .bss)\n\
  }\n\
  .noinit 0 :\n\
  {\n\
    *(.noinit)\n\
  }\n\
  .persistent 0 :\n\
  {\n\
    *(.persistent)\n\
  }\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n"
"  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
}\n\n"
  ; else if (!config.text_read_only) return
"/* Script for -N */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
ENTRY (_start)\n\
MEMORY\n\
{\n\
  text   (rx)		: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)		: ORIGIN = 0x0500,	LENGTH = 1K\n\
  vectors (rw)		: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader   :\n\
  {\n\
     PROVIDE (__boot_start = .) ;\n\
    *(.bootloader)\n\
    . = ALIGN(2);\n"
"    *(.bootloader.*)\n\
  }  > bootloader\n\
  /* Information memory.  */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
    . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
    . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomemnobits\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          : { *(.hash)             }\n\
  .dynsym        : { *(.dynsym)           }\n\
  .dynstr        : { *(.dynstr)           }\n\
  .gnu.version   : { *(.gnu.version)      }\n\
  .gnu.version_d   : { *(.gnu.version_d)  }\n\
  .gnu.version_r   : { *(.gnu.version_r)  }\n\
  .rel.text      :\n\
    {\n"
"      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n"
"      *(.rel.data.*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)        }\n\
  .rela.ctors    : { *(.rela.ctors)       }\n\
  .rel.dtors     : { *(.rel.dtors)        }\n\
  .rela.dtors    : { *(.rela.dtors)       }\n\
  .rel.got       : { *(.rel.got)          }\n\
  .rela.got      : { *(.rela.got)         }\n\
  .rel.bss       : { *(.rel.bss)          }\n\
  .rela.bss      : { *(.rela.bss)         }\n\
  .rel.plt       : { *(.rel.plt)          }\n\
  .rela.plt      : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text   :\n\
  {\n\
    . = ALIGN(2);\n\
    PROVIDE (_start = .);\n\
    KEEP (*(SORT(.crt_*)))\n"
"     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    . = ALIGN(2);\n\
    *(.lower.text.* .lower.text)\n\
    . = ALIGN(2);\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n\
    *(.upper.text.* .upper.text)\n\
    . = ALIGN(2);\n\
    _etext = .;\n\
  }  > text\n\
  .rodata   :\n\
  {\n\
    . = ALIGN(2);\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    . = ALIGN(2);\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    . = ALIGN(2);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    . = ALIGN(2);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }  > text\n\
  .vectors   :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    *(.vectors*)\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .data   :\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
     PROVIDE (__datastart = .) ;\n\
    . = ALIGN(2);\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    . = ALIGN(2);\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    . = ALIGN(2);\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
    . = ALIGN(2);\n\
    _edata = .;\n\
  }  > data AT> text\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    . = ALIGN(2);\n\
     PROVIDE (__bss_start = .);\n\
     PROVIDE (__bssstart = .);\n\
    *(.lower.bss.* .lower.bss)\n\
    . = ALIGN(2);\n\
    *(.bss.* .bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
    PROVIDE (__bss_end = .);\n\
  }  > data\n\
   PROVIDE (__bsssize = SIZEOF(.bss));\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit)\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > data\n\
  .persistent  SIZEOF(.noinit) + ADDR(.noinit) :\n\
  {\n\
     PROVIDE (__persistent_start = .) ;\n\
    *(.persistent)\n\
     PROVIDE (__persistent_end = .) ;\n\
  }  > data\n\
   _end = . ;\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"/* Script for -n */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
ENTRY (_start)\n\
MEMORY\n\
{\n\
  text   (rx)		: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)		: ORIGIN = 0x0500,	LENGTH = 1K\n\
  vectors (rw)		: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader   :\n\
  {\n\
     PROVIDE (__boot_start = .) ;\n\
    *(.bootloader)\n\
    . = ALIGN(2);\n"
"    *(.bootloader.*)\n\
  }  > bootloader\n\
  /* Information memory.  */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
    . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
    . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomemnobits\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          : { *(.hash)             }\n\
  .dynsym        : { *(.dynsym)           }\n\
  .dynstr        : { *(.dynstr)           }\n\
  .gnu.version   : { *(.gnu.version)      }\n\
  .gnu.version_d   : { *(.gnu.version_d)  }\n\
  .gnu.version_r   : { *(.gnu.version_r)  }\n\
  .rel.text      :\n\
    {\n"
"      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n"
"      *(.rel.data.*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)        }\n\
  .rela.ctors    : { *(.rela.ctors)       }\n\
  .rel.dtors     : { *(.rel.dtors)        }\n\
  .rela.dtors    : { *(.rela.dtors)       }\n\
  .rel.got       : { *(.rel.got)          }\n\
  .rela.got      : { *(.rela.got)         }\n\
  .rel.bss       : { *(.rel.bss)          }\n\
  .rela.bss      : { *(.rela.bss)         }\n\
  .rel.plt       : { *(.rel.plt)          }\n\
  .rela.plt      : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text   :\n\
  {\n\
    . = ALIGN(2);\n\
    PROVIDE (_start = .);\n\
    KEEP (*(SORT(.crt_*)))\n"
"     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    . = ALIGN(2);\n\
    *(.lower.text.* .lower.text)\n\
    . = ALIGN(2);\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n\
    *(.upper.text.* .upper.text)\n\
    . = ALIGN(2);\n\
    _etext = .;\n\
  }  > text\n\
  .rodata   :\n\
  {\n\
    . = ALIGN(2);\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    . = ALIGN(2);\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    . = ALIGN(2);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    . = ALIGN(2);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }  > text\n\
  .vectors   :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    *(.vectors*)\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .data   :\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
     PROVIDE (__datastart = .) ;\n\
    . = ALIGN(2);\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    . = ALIGN(2);\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    . = ALIGN(2);\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
    . = ALIGN(2);\n\
    _edata = .;\n\
  }  > data AT> text\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    . = ALIGN(2);\n\
     PROVIDE (__bss_start = .);\n\
     PROVIDE (__bssstart = .);\n\
    *(.lower.bss.* .lower.bss)\n\
    . = ALIGN(2);\n\
    *(.bss.* .bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
    PROVIDE (__bss_end = .);\n\
  }  > data\n\
   PROVIDE (__bsssize = SIZEOF(.bss));\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit)\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > data\n\
  .persistent  SIZEOF(.noinit) + ADDR(.noinit) :\n\
  {\n\
     PROVIDE (__persistent_start = .) ;\n\
    *(.persistent)\n\
     PROVIDE (__persistent_end = .) ;\n\
  }  > data\n\
   _end = . ;\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
  ; else return
"/* Default linker script, for normal executables */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
ENTRY (_start)\n\
MEMORY\n\
{\n\
  text   (rx)		: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)		: ORIGIN = 0x0500,	LENGTH = 1K\n\
  vectors (rw)		: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader   :\n\
  {\n\
     PROVIDE (__boot_start = .) ;\n\
    *(.bootloader)\n\
    . = ALIGN(2);\n"
"    *(.bootloader.*)\n\
  }  > bootloader\n\
  /* Information memory.  */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
    . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
    . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomemnobits\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          : { *(.hash)             }\n\
  .dynsym        : { *(.dynsym)           }\n\
  .dynstr        : { *(.dynstr)           }\n\
  .gnu.version   : { *(.gnu.version)      }\n\
  .gnu.version_d   : { *(.gnu.version_d)  }\n\
  .gnu.version_r   : { *(.gnu.version_r)  }\n\
  .rel.text      :\n\
    {\n"
"      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n"
"      *(.rel.data.*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)        }\n\
  .rela.ctors    : { *(.rela.ctors)       }\n\
  .rel.dtors     : { *(.rel.dtors)        }\n\
  .rela.dtors    : { *(.rela.dtors)       }\n\
  .rel.got       : { *(.rel.got)          }\n\
  .rela.got      : { *(.rela.got)         }\n\
  .rel.bss       : { *(.rel.bss)          }\n\
  .rela.bss      : { *(.rela.bss)         }\n\
  .rel.plt       : { *(.rel.plt)          }\n\
  .rela.plt      : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text   :\n\
  {\n\
    . = ALIGN(2);\n\
    PROVIDE (_start = .);\n\
    KEEP (*(SORT(.crt_*)))\n"
"     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    . = ALIGN(2);\n\
    *(.lower.text.* .lower.text)\n\
    . = ALIGN(2);\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n\
    *(.upper.text.* .upper.text)\n\
    . = ALIGN(2);\n\
    _etext = .;\n\
  }  > text\n\
  .rodata   :\n\
  {\n\
    . = ALIGN(2);\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    . = ALIGN(2);\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    . = ALIGN(2);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    . = ALIGN(2);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }  > text\n\
  .vectors   :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    *(.vectors*)\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .data   :\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
     PROVIDE (__datastart = .) ;\n\
    . = ALIGN(2);\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    . = ALIGN(2);\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    . = ALIGN(2);\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
    . = ALIGN(2);\n\
    _edata = .;\n\
  }  > data AT> text\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    . = ALIGN(2);\n\
     PROVIDE (__bss_start = .);\n\
     PROVIDE (__bssstart = .);\n\
    *(.lower.bss.* .lower.bss)\n\
    . = ALIGN(2);\n\
    *(.bss.* .bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
    PROVIDE (__bss_end = .);\n\
  }  > data\n\
   PROVIDE (__bsssize = SIZEOF(.bss));\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit)\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > data\n\
  .persistent  SIZEOF(.noinit) + ADDR(.noinit) :\n\
  {\n\
     PROVIDE (__persistent_start = .) ;\n\
    *(.persistent)\n\
     PROVIDE (__persistent_end = .) ;\n\
  }  > data\n\
   _end = . ;\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .debug_addr     0 : { *(.debug_addr) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
; }

static unsigned int
data_statement_size (lang_data_statement_type *d)
{
  unsigned int size = 0;
  switch (d->type)
    {
    case QUAD:
    case SQUAD:
      size = QUAD_SIZE;
      break;
    case LONG:
      size = LONG_SIZE;
      break;
    case SHORT:
      size = SHORT_SIZE;
      break;
    case BYTE:
      size = BYTE_SIZE;
      break;
    default:
      einfo (_("%P: error: unhandled data_statement size\n"));
      FAIL ();
    }
  return size;
}

/* Helper function for place_orphan that computes the size
   of sections already mapped to the given statement.  */

static bfd_size_type
scan_children (lang_statement_union_type * l)
{
  bfd_size_type amount = 0;

  while (l != NULL)
    {
      switch (l->header.type)
	{
	case lang_input_section_enum:
	  if (l->input_section.section->flags & SEC_ALLOC)
	    amount += l->input_section.section->size;
	  break;

	case lang_constructors_statement_enum:
	case lang_assignment_statement_enum:
	case lang_padding_statement_enum:
	  break;

	case lang_wild_statement_enum:
	  amount += scan_children (l->wild_statement.children.head);
	  break;

	case lang_data_statement_enum:
	  amount += data_statement_size (&l->data_statement);
	  break;

	default:
	  fprintf (stderr, "msp430 orphan placer: unhandled lang type %d\n", l->header.type);
	  break;
	}

      l = l->header.next;
    }

  return amount;
}

#define WARN_UPPER 0
#define WARN_LOWER 1
#define WARN_TEXT 0
#define WARN_DATA 1
#define WARN_BSS 2
#define WARN_RODATA 3

/* Warn only once per output section.
 * NAME starts with ".upper." or ".lower.".  */
static void
warn_no_output_section (const char *name)
{
  static bfd_boolean warned[2][4] = {{FALSE, FALSE, FALSE, FALSE},
				     {FALSE, FALSE, FALSE, FALSE}};
  int i = WARN_LOWER;

  if (strncmp (name, ".upper.", 7) == 0)
    i = WARN_UPPER;

  if (!warned[i][WARN_TEXT] && strcmp (name + 6, ".text") == 0)
    warned[i][WARN_TEXT] = TRUE;
  else if (!warned[i][WARN_DATA] && strcmp (name + 6, ".data") == 0)
    warned[i][WARN_DATA] = TRUE;
  else if (!warned[i][WARN_BSS] && strcmp (name + 6, ".bss") == 0)
    warned[i][WARN_BSS] = TRUE;
  else if (!warned[i][WARN_RODATA] && strcmp (name + 6, ".rodata") == 0)
    warned[i][WARN_RODATA] = TRUE;
  else
    return;
  einfo ("%P: warning: no input section rule matches %s in linker script\n",
	 name);
}

/* Given an input section S, which will not be present in the final linked
   executable due to a missing linker script rule to match it, warn the user
   that it has not been recognized if it is an interrupt vector section.
   GCC allows any string to be passed to the "interrupt" attribute, so the
   linker must perform the verification that the string corresponds to a
   real slot in the interrupt vector table.
   Retun TRUE if S is an interrupt vector section, to indicate there is
   nothing more to do.  */
static bfd_boolean
report_removed_interrupt_vector_section (asection *s)
{
  const char * vect_str = "__interrupt_vector_";
  if (bfd_link_relocatable (&link_info))
    return FALSE;

  if (strncmp (s->name, vect_str, strlen (vect_str)) == 0)
    {
      einfo ("%P: warning: linker script %pU does not recognize interrupt "
	     "vector section name %s\n", NULL, s->name);
      return TRUE;
    }
  return FALSE;
}

/* Place an orphan section.  We use this to put .either sections
   into either their lower or their upper equivalents.  */

static lang_output_section_statement_type *
gldmsp430elf_place_orphan (asection * s,
				   const char * secname,
				   int constraint)
{
  char * lower_name;
  char * upper_name;
  char * name;
  lang_output_section_statement_type * lower;
  lang_output_section_statement_type * upper;

  /* An orphaned interrupt vector section means there is no matching rule for it
     in the linker script.  */
  if (report_removed_interrupt_vector_section (s))
    return NULL;

  if ((s->flags & SEC_ALLOC) == 0
      || bfd_link_relocatable (&link_info)
      /* If constraints are involved let the linker handle the placement normally.  */
      || constraint != 0)
    return ldelf_place_orphan (s, secname, constraint);

  if (strncmp (secname, ".upper.", 7) == 0
      || strncmp (secname, ".lower.", 7) == 0)
    {
      warn_no_output_section (secname);
      return ldelf_place_orphan (s, secname, constraint);
    }

  /* We only need special handling for .either sections.  */
  if (strncmp (secname, ".either.", 8) != 0)
    return ldelf_place_orphan (s, secname, constraint);

  /* Skip the .either prefix.  */
  secname += 7;

  /* Compute the names of the corresponding upper and lower
     sections.  If the input section name contains another period,
     only use the part of the name before the second dot.  */
  if (strchr (secname + 1, '.') != NULL)
    {
      name = xstrdup (secname);

      * strchr (name + 1, '.') = 0;
    }
  else
    name = (char *) secname;

  lower_name = concat (".lower", name, NULL);
  upper_name = concat (".upper", name, NULL);

  /* Find the corresponding lower and upper sections.  */
  lower = lang_output_section_find (lower_name);
  upper = lang_output_section_find (upper_name);

  /* If there isn't an output section beginning with .lower, use the
     un-prefixed output section.  */
  if (lower == NULL)
    lower = lang_output_section_find (name);

  if (lower == NULL)
    {
      /* If lower is still NULL, that means there's no .lower.X or .X output
	 section, which would be very strange.  The linker will create .text,
	 .data and .bss sections even if they are not named in the linker
	 script, but it won't create .rodata.  So this will only catch
	 .either.rodata.  */
      einfo (_("%P: warning: no section named %s or %s in linker script, "
	       "required to shuffle %s between regions\n"),
	     lower_name, name, s->name);
      goto end;
    }
  else if (upper == NULL)
    {
      /* We have a lower output section, but no upper.  */
      einfo (_("%P: warning: no section named %s in linker script, "
	       "required to shuffle %s between regions\n"),
	     upper_name, s->name);
      goto end;
    }

  /* Always place orphaned sections in lower.  Optimal placement of either
     sections is performed later, once section sizes have been finalized.  */
  lang_add_section (& lower->children, s, NULL, lower);
 end:
  free (upper_name);
  free (lower_name);
  return ldelf_place_orphan (s, (lower ? lower->name : secname), constraint);
}

/* This function is similar to lang_relax_sections, but without the size
   evaluation code that is always executed after relaxation.  */
static void
intermediate_relax_sections (void)
{
  int i = link_info.relax_pass;

  /* The backend can use it to determine the current pass.  */
  link_info.relax_pass = 0;

  while (i--)
    {
      bfd_boolean relax_again;

      link_info.relax_trip = -1;
      do
	{
	  link_info.relax_trip++;

	  lang_do_assignments (lang_assigning_phase_enum);

	  lang_reset_memory_regions ();

	  relax_again = FALSE;
	  lang_size_sections (&relax_again, FALSE);
	}
      while (relax_again);

      link_info.relax_pass++;
    }
}

/* The same as insert_wild but with intermediate_relax_sections instead of
   lang_relax_sections.  */
static lang_wild_statement_type *
add_wild_for_either (lang_statement_list_type *list)
{
  lang_wild_statement_type *wild = NULL;

  wild = stat_alloc (sizeof (lang_wild_statement_type));
  wild->header.next = NULL;
  wild->header.type = lang_wild_statement_enum;

  wild->filename = NULL;
  wild->filenames_sorted = FALSE;
  wild->section_flag_list = NULL;
  wild->exclude_name_list = NULL;
  wild->section_list = NULL;
  wild->keep_sections = FALSE;
  lang_list_init (&wild->children);

  *(list->tail) = (void *)wild;
  list->tail = &wild->header.next;

  /* We can't do regular lang_relax_sections during either shuffling, which is
     why we must use this variant of insert_wild that does
     intermediate_relax_sections instead.  */
  intermediate_relax_sections ();

  return wild;
}


static bfd_boolean
change_output_section (lang_statement_union_type ** head,
		       asection *s,
		       lang_output_section_statement_type * new_os,
		       lang_output_section_statement_type * old_os)
{
  asection *is;
  lang_statement_union_type * prev = NULL;
  lang_statement_union_type * curr;

  curr = *head;
  while (curr != NULL)
    {
      switch (curr->header.type)
	{
	case lang_input_section_enum:
	  is = curr->input_section.section;
	  if (is == s)
	    {
	      lang_statement_list_type *old_list;
	      lang_wild_statement_type *wild;

	      wild = add_wild_for_either (&new_os->children);

	      s->output_section = NULL;

	      if (wild)
		lang_add_section (&wild->children, s, NULL, new_os);
	      else
		einfo (_("%P: error: could not shuffle \"either\" section %s\n"), s->name);

	      /* Remove the section from the old output section.  */
	      if (prev == NULL)
		*head = curr->header.next;
	      else
		prev->header.next = curr->header.next;

	      /* If the input section we just moved is the tail of the old
		 output section, then we also need to adjust that tail.  */
	      old_list = (lang_statement_list_type *)&old_os->children;
	      if (old_list->tail == (lang_statement_union_type **)curr)
		old_list->tail = (lang_statement_union_type **)prev;

	      return TRUE;
	    }
	  break;
	case lang_wild_statement_enum:
	  if (change_output_section (&(curr->wild_statement.children.head),
				     s, new_os, old_os))
	    return TRUE;
	  break;
	default:
	  break;
	}
      prev = curr;
      curr = curr->header.next;
    }
  return FALSE;
}

static void
add_region_prefix (bfd *abfd ATTRIBUTE_UNUSED, asection *s,
		   void *unused ATTRIBUTE_UNUSED)
{
  const char *curr_name = bfd_section_name (s);
  int region = REGION_NONE;

  if (strncmp (curr_name, ".text", 5) == 0)
    region = code_region;
  else if (strncmp (curr_name, ".data", 5) == 0)
    region = data_region;
  else if (strncmp (curr_name, ".bss", 4) == 0)
    region = data_region;
  else if (strncmp (curr_name, ".rodata", 7) == 0)
    region = data_region;
  else
    return;

  switch (region)
    {
    case REGION_NONE:
      break;
    case REGION_UPPER:
      bfd_rename_section (s, concat (".upper", curr_name, NULL));
      break;
    case REGION_LOWER:
      bfd_rename_section (s, concat (".lower", curr_name, NULL));
      break;
    case REGION_EITHER:
      s->name = concat (".either", curr_name, NULL);
      break;
    default:
      /* Unreachable.  */
      FAIL ();
      break;
    }
}

static void
msp430_elf_after_open (void)
{
  bfd *abfd;

  gldmsp430elf_after_open ();

  /* If neither --code-region or --data-region have been passed, do not
     transform sections names.  */
  if ((code_region == REGION_NONE && data_region == REGION_NONE)
      || disable_sec_transformation)
    return;

  for (abfd = link_info.input_bfds; abfd != NULL; abfd = abfd->link.next)
    bfd_map_over_sections (abfd, add_region_prefix, NULL);
}

#define OPTION_CODE_REGION		321
#define OPTION_DATA_REGION		(OPTION_CODE_REGION + 1)
#define OPTION_DISABLE_TRANS		(OPTION_CODE_REGION + 2)

static void
gldmsp430elf_add_options
  (int ns, char **shortopts, int nl, struct option **longopts,
   int nrl ATTRIBUTE_UNUSED, struct option **really_longopts ATTRIBUTE_UNUSED)
{
  static const char xtra_short[] = { };

  static const struct option xtra_long[] =
    {
      { "code-region", required_argument, NULL, OPTION_CODE_REGION },
      { "data-region", required_argument, NULL, OPTION_DATA_REGION },
      { "disable-sec-transformation", no_argument, NULL,
	OPTION_DISABLE_TRANS },
      { NULL, no_argument, NULL, 0 }
    };

  *shortopts = (char *) xrealloc (*shortopts, ns + sizeof (xtra_short));
  memcpy (*shortopts + ns, &xtra_short, sizeof (xtra_short));
  *longopts = (struct option *)
    xrealloc (*longopts, nl * sizeof (struct option) + sizeof (xtra_long));
  memcpy (*longopts + nl, &xtra_long, sizeof (xtra_long));
}

static void
gldmsp430elf_list_options (FILE * file)
{
  fprintf (file, _("  --code-region={either,lower,upper,none}\n        Transform .text* sections to {either,lower,upper,none}.text* sections\n"));
  fprintf (file, _("  --data-region={either,lower,upper,none}\n        Transform .data*, .rodata* and .bss* sections to\n        {either,lower,upper,none}.{bss,data,rodata}* sections\n"));
  fprintf (file, _("  --disable-sec-transformation\n        Disable transformation of .{text,data,bss,rodata}* sections to\n        add the {either,lower,upper,none} prefixes\n"));
}

static bfd_boolean
gldmsp430elf_handle_option (int optc)
{
  switch (optc)
    {
    case OPTION_CODE_REGION:
      if (strcmp (optarg, "upper") == 0)
	code_region = REGION_UPPER;
      else if (strcmp (optarg, "lower") == 0)
	code_region = REGION_LOWER;
      else if (strcmp (optarg, "either") == 0)
	code_region = REGION_EITHER;
      else if (strcmp (optarg, "none") == 0)
	code_region = REGION_NONE;
      else if (strlen (optarg) == 0)
	{
	  einfo (_("%P: --code-region requires an argument: "
		   "{upper,lower,either,none}\n"));
	  return FALSE;
	}
      else
	{
	  einfo (_("%P: error: unrecognized argument to --code-region= option: "
		   "\"%s\"\n"), optarg);
	  return FALSE;
	}
      break;

    case OPTION_DATA_REGION:
      if (strcmp (optarg, "upper") == 0)
	data_region = REGION_UPPER;
      else if (strcmp (optarg, "lower") == 0)
	data_region = REGION_LOWER;
      else if (strcmp (optarg, "either") == 0)
	data_region = REGION_EITHER;
      else if (strcmp (optarg, "none") == 0)
	data_region = REGION_NONE;
      else if (strlen (optarg) == 0)
	{
	  einfo (_("%P: --data-region requires an argument: "
		   "{upper,lower,either,none}\n"));
	  return FALSE;
	}
      else
	{
	  einfo (_("%P: error: unrecognized argument to --data-region= option: "
		   "\"%s\"\n"), optarg);
	  return FALSE;
	}
      break;

    case OPTION_DISABLE_TRANS:
      disable_sec_transformation = TRUE;
      break;

    default:
      return FALSE;
    }
  return TRUE;
}

static void
eval_upper_either_sections (bfd *abfd ATTRIBUTE_UNUSED,
			    asection *s, void *data)
{
  const char * base_sec_name;
  const char * curr_name;
  char * either_name;
  int curr_region;

  lang_output_section_statement_type * lower;
  lang_output_section_statement_type * upper;
  static bfd_size_type *lower_size = 0;
  static bfd_size_type *upper_size = 0;
  static bfd_size_type lower_size_rom = 0;
  static bfd_size_type lower_size_ram = 0;
  static bfd_size_type upper_size_rom = 0;
  static bfd_size_type upper_size_ram = 0;

  if ((s->flags & SEC_ALLOC) == 0)
    return;
  if (bfd_link_relocatable (&link_info))
    return;

  base_sec_name = (const char *) data;
  curr_name = bfd_section_name (s);

  /* Only concerned with .either input sections in the upper output section.  */
  either_name = concat (".either", base_sec_name, NULL);
  if (strncmp (curr_name, either_name, strlen (either_name)) != 0
      || strncmp (s->output_section->name, ".upper", 6) != 0)
    goto end;

  lower = lang_output_section_find (concat (".lower", base_sec_name, NULL));
  upper = lang_output_section_find (concat (".upper", base_sec_name, NULL));

  if (upper == NULL || upper->region == NULL)
    goto end;
  else if (lower == NULL)
    lower = lang_output_section_find (base_sec_name);
  if (lower == NULL || lower->region == NULL)
    goto end;

  if (strcmp (base_sec_name, ".text") == 0
      || strcmp (base_sec_name, ".rodata") == 0)
    curr_region = ROM;
  else
    curr_region = RAM;

  if (curr_region == ROM)
    {
      if (lower_size_rom == 0)
	{
	  lower_size_rom = lower->region->current - lower->region->origin;
	  upper_size_rom = upper->region->current - upper->region->origin;
	}
      lower_size = &lower_size_rom;
      upper_size = &upper_size_rom;
    }
  else if (curr_region == RAM)
    {
      if (lower_size_ram == 0)
	{
	  lower_size_ram = lower->region->current - lower->region->origin;
	  upper_size_ram = upper->region->current - upper->region->origin;
	}
      lower_size = &lower_size_ram;
      upper_size = &upper_size_ram;
    }

  /* If the upper region is overflowing, try moving sections to the lower
     region.
     Note that there isn't any general benefit to using lower memory over upper
     memory, so we only move sections around with the goal of making the program
     fit.  */
  if (*upper_size > upper->region->length
      && *lower_size + s->size < lower->region->length)
    {
      if (change_output_section (&(upper->children.head), s, lower, upper))
	{
	  *upper_size -= s->size;
	  *lower_size += s->size;
	}
    }
 end:
  free (either_name);
}

static void
eval_lower_either_sections (bfd *abfd ATTRIBUTE_UNUSED,
			    asection *s, void *data)
{
  const char * base_sec_name;
  const char * curr_name;
  char * either_name;
  int curr_region;
  lang_output_section_statement_type * output_sec;
  lang_output_section_statement_type * lower;
  lang_output_section_statement_type * upper;

  static bfd_size_type *lower_size = 0;
  static bfd_size_type lower_size_rom = 0;
  static bfd_size_type lower_size_ram = 0;

  if ((s->flags & SEC_ALLOC) == 0)
    return;
  if (bfd_link_relocatable (&link_info))
    return;

  base_sec_name = (const char *) data;
  curr_name = bfd_section_name (s);

  /* Only concerned with .either input sections in the lower or "default"
     output section i.e. not in the upper output section.  */
  either_name = concat (".either", base_sec_name, NULL);
  if (strncmp (curr_name, either_name, strlen (either_name)) != 0
      || strncmp (s->output_section->name, ".upper", 6) == 0)
    return;

  if (strcmp (base_sec_name, ".text") == 0
      || strcmp (base_sec_name, ".rodata") == 0)
    curr_region = ROM;
  else
    curr_region = RAM;

  output_sec = lang_output_section_find (s->output_section->name);

  /* If the output_section doesn't exist, this has already been reported in
     place_orphan, so don't need to warn again.  */
  if (output_sec == NULL || output_sec->region == NULL)
    goto end;

  /* lower and output_sec might be the same, but in some cases an .either
     section can end up in base_sec_name if it hasn't been placed by
     place_orphan.  */
  lower = lang_output_section_find (concat (".lower", base_sec_name, NULL));
  upper = lang_output_section_find (concat (".upper", base_sec_name, NULL));
  if (upper == NULL)
    goto end;

  if (curr_region == ROM)
    {
      if (lower_size_rom == 0)
	{
	  /* Get the size of other items in the lower region that aren't the
	     sections to be moved around.  */
	  lower_size_rom
	    = (output_sec->region->current - output_sec->region->origin)
	    - scan_children (output_sec->children.head);
	  if (output_sec != lower && lower != NULL)
	    lower_size_rom -= scan_children (lower->children.head);
	}
      lower_size = &lower_size_rom;
    }
  else if (curr_region == RAM)
    {
      if (lower_size_ram == 0)
	{
	  lower_size_ram
	    = (output_sec->region->current - output_sec->region->origin)
	    - scan_children (output_sec->children.head);
	  if (output_sec != lower && lower != NULL)
	    lower_size_ram -= scan_children (lower->children.head);
	}
      lower_size = &lower_size_ram;
    }
  /* Move sections that cause the lower region to overflow to the upper region.  */
  if (*lower_size + s->size > output_sec->region->length)
    change_output_section (&(output_sec->children.head), s, upper, output_sec);
  else
    *lower_size += s->size;
 end:
  free (either_name);
}

static void
msp430_elf_after_allocation (void)
{
  int relax_count = 0;
  unsigned int i;
  /* Go over each section twice, once to place either sections that don't fit
     in lower into upper, and then again to move any sections in upper that
     fit in lower into lower.  */
  for (i = 0; i < 8; i++)
    {
      int placement_stage = (i < 4) ? LOWER_TO_UPPER : UPPER_TO_LOWER;
      const char * base_sec_name;
      lang_output_section_statement_type * upper;

      switch (i % 4)
	{
	default:
	case 0:
	  base_sec_name = ".text";
	  break;
	case 1:
	  base_sec_name = ".data";
	  break;
	case 2:
	  base_sec_name = ".bss";
	  break;
	case 3:
	  base_sec_name = ".rodata";
	  break;
	}
      upper = lang_output_section_find (concat (".upper", base_sec_name, NULL));
      if (upper != NULL)
	{
	  /* Can't just use one iteration over the all the sections to make
	     both lower->upper and upper->lower transformations because the
	     iterator encounters upper sections before all lower sections have
	     been examined.  */
	  bfd *abfd;

	  if (placement_stage == LOWER_TO_UPPER)
	    {
	      /* Perform relaxation and get the final size of sections
		 before trying to fit .either sections in the correct
		 ouput sections.  */
	      if (relax_count == 0)
		{
		  intermediate_relax_sections ();
		  relax_count++;
		}
	      for (abfd = link_info.input_bfds; abfd != NULL;
		   abfd = abfd->link.next)
		{
		  bfd_map_over_sections (abfd, eval_lower_either_sections,
					 (void *) base_sec_name);
		}
	    }
	  else if (placement_stage == UPPER_TO_LOWER)
	    {
	      /* Relax again before moving upper->lower.  */
	      if (relax_count == 1)
		{
		  intermediate_relax_sections ();
		  relax_count++;
		}
	      for (abfd = link_info.input_bfds; abfd != NULL;
		   abfd = abfd->link.next)
		{
		  bfd_map_over_sections (abfd, eval_upper_either_sections,
					 (void *) base_sec_name);
		}
	    }

	}
    }
  gldmsp430elf_after_allocation ();
}

/* Return TRUE if a non-debug input section in L has positive size and matches
   the given name.  */
static int
input_section_exists (lang_statement_union_type * l, const char * name)
{
  while (l != NULL)
    {
      switch (l->header.type)
	{
	case lang_input_section_enum:
	  if ((l->input_section.section->flags & SEC_ALLOC)
	      && l->input_section.section->size > 0
	      && !strcmp (l->input_section.section->name, name))
	    return TRUE;
	  break;

	case lang_wild_statement_enum:
	  if (input_section_exists (l->wild_statement.children.head, name))
	    return TRUE;
	  break;

	default:
	  break;
	}
      l = l->header.next;
    }
  return FALSE;
}

/* Some MSP430 linker scripts do not include ALIGN directives to ensure
   __preinit_array_start, __init_array_start or __fini_array_start are word
   aligned.
   If __*_array_start symbols are not word aligned, the code in crt0 to run
   through the array and call the functions will crash.
   To avoid warning unnecessarily when the .*_array sections are not being
   used for running constructors/destructors, we only emit the warning if
   the associated section exists and has size.  */
static void
check_array_section_alignment (void)
{
  int i;
  lang_output_section_statement_type * rodata_sec;
  lang_output_section_statement_type * rodata2_sec;
  const char * array_names[3][2] = { { ".init_array", "__init_array_start" },
	{ ".preinit_array", "__preinit_array_start" },
	{ ".fini_array", "__fini_array_start" } };

  /* .{preinit,init,fini}_array could be in either .rodata or .rodata2.  */
  rodata_sec = lang_output_section_find (".rodata");
  rodata2_sec = lang_output_section_find (".rodata2");
  if (rodata_sec == NULL && rodata2_sec == NULL)
    return;

  /* There are 3 .*_array sections which must be checked for alignment.  */
  for (i = 0; i < 3; i++)
    {
      struct bfd_link_hash_entry * sym;
      if (((rodata_sec && input_section_exists (rodata_sec->children.head,
						array_names[i][0]))
	   || (rodata2_sec && input_section_exists (rodata2_sec->children.head,
						    array_names[i][0])))
	  && (sym = bfd_link_hash_lookup (link_info.hash, array_names[i][1],
					  FALSE, FALSE, TRUE))
	  && sym->type == bfd_link_hash_defined
	  && sym->u.def.value % 2)
	{
	  einfo ("%P: warning: \"%s\" symbol (%pU) is not word aligned\n",
		 array_names[i][1], NULL);
	}
    }
}

static void
check_interrupt_vector_used (bfd *abfd ATTRIBUTE_UNUSED,
			     asection *s, void *data ATTRIBUTE_UNUSED)
{
  /* If this section has been garbage collected, check if it is an interrupt
     vector section.  */
  if (s->gc_mark == 0)
    report_removed_interrupt_vector_section (s);
}

static void
gldmsp430elf_finish (void)
{
  finish_default ();
  check_array_section_alignment ();

  /* If garbage collection is enabled, a missing linker script rule for an
     interrupt vector section will result in it being completely removed,
     rather than orphaned.  So that case needs to be handled here.  */
  if (link_info.gc_sections)
    {
      bfd *abfd;
      for (abfd = link_info.input_bfds; abfd != NULL; abfd = abfd->link.next)
	bfd_map_over_sections (abfd, check_interrupt_vector_used, NULL);
    }
}

struct ld_emulation_xfer_struct ld_msp430elf_emulation =
{
  gldmsp430elf_before_parse,
  syslib_default,
  hll_default,
  after_parse_default,
  msp430_elf_after_open,
  after_check_relocs_default,
  msp430_elf_after_allocation,
  set_output_arch_default,
  ldemul_default_target,
  gldmsp430elf_before_allocation,
  gldmsp430elf_get_script,
  "msp430elf",
  "elf32-msp430",
  gldmsp430elf_finish,
  NULL,
  NULL,
  gldmsp430elf_place_orphan,
  NULL,
  NULL,
  gldmsp430elf_add_options,
  gldmsp430elf_handle_option,
  NULL,
  gldmsp430elf_list_options,
  NULL,
  NULL,
  NULL,
  NULL,
  ldelf_emit_ctf_early,
  ldelf_examine_strtab_for_ctf
};
